;-------------------------------------------------------------------------------------------------------------
;Converted to AutoIT by Andrew Calcutt - http://www.techidiots.net/autoit-scripts/circle%20generator.au3/view - 5/29/2007
;Based of the source code avalible here http://dev.bt23.org/keyhole/circlegen/output.phps - http://dev.bt23.org/keyhole/circlegen/
;-------------------------------------------------------------------------------------------------------------
#include <GuiConstants.au3>

;declair variables
Dim $PI = 4 * ATan(1)
Dim $viewdistance = 500
Dim $defaultfilename = @MON & '-' & @MDAY & '-' & @YEAR & '_' & @HOUR & '-' & @MIN & '-' & @SEC & '.kml'
Dim $defaultradius = 100

GUICreate("Circle Generator 2", 384, 229, -1, -1, BitOR($WS_OVERLAPPEDWINDOW, $WS_CLIPSIBLINGS))
GUICtrlCreateLabel("Latitude:", 20, 20, 50, 20)
$gui_cen_lat = GUICtrlCreateInput("", 100, 20, 250, 20)
GUICtrlCreateLabel("Longitude:", 20, 50, 50, 20)
$gui_cen_lon = GUICtrlCreateInput("", 100, 50, 250, 20)
GUICtrlCreateLabel("Radius:", 20, 80, 40, 20)
$gui_rad = GUICtrlCreateInput($defaultradius, 100, 80, 250, 20)
GUICtrlCreateLabel("View Distance:", 20, 110, 80, 20)
$gui_view_distance = GUICtrlCreateInput($viewdistance, 100, 110, 250, 20)
GUICtrlCreateLabel("File Name:", 20, 140, 70, 20)
$gui_filename = GUICtrlCreateInput($defaultfilename, 100, 140, 250, 20)
$create_file = GUICtrlCreateButton("Create File", 120, 170, 140, 40)




GUISetState()
While 1
	$msg = GUIGetMsg()
	Select
		Case $msg = $create_file
			$filename = GUICtrlRead($gui_filename)
			$centerlat_form = GUICtrlRead($gui_cen_lat)
			$centerlong_form = GUICtrlRead($gui_cen_lon)
			$radius_form = GUICtrlRead($gui_rad)
			$viewdistance_form = GUICtrlRead($gui_view_distance)
			;delete old file if it exists
			FileDelete($filename)
			
			; convert coordinates to radians
			$lat1 = _deg2rad($centerlat_form)
			$long1 = _deg2rad($centerlong_form)
			;not sure what this does, but it was in the origional script
			$d_rad = $radius_form / 6378137
			
			;create header
			$file = '<?xml version="1.0" encoding="UTF-8"?>' & @CRLF & _
					'<kml xmlns="http://earth.google.com/kml/2.1">' & @CRLF & _
					'<Document>' & @CRLF & _
					'<name>' & $filename & '</name>' & @CRLF & _
					'<open>1</open>' & @CRLF & _
					'<Style id="Location">' & @CRLF & _
					'<LineStyle>' & @CRLF & _
					'<color>7f0000ff</color>' & @CRLF & _
					'<width>2</width>' & @CRLF & _
					'</LineStyle>' & @CRLF & _
					'</Style>' & @CRLF & _
					'<Placemark>' & @CRLF & _
					'<name>Location</name>' & @CRLF & _
					'<styleUrl>#Location</styleUrl>' & @CRLF & _
					'<LineString>' & @CRLF & _
					'<extrude>1</extrude>' & @CRLF & _
					'<tessellate>1</tessellate>' & @CRLF & _
					'<coordinates>' & @CRLF
			
			; loop through the array and write path linestrings
			For $i = 0 To 360
				$radial = _deg2rad($i)
				$lat_rad = ASin(Sin($lat1) * Cos($d_rad) + Cos($lat1) * Sin($d_rad) * Cos($radial))
				$dlon_rad = ATan(Sin($radial) * Sin($d_rad) * Cos($lat1)) / (Cos($d_rad) - Sin($lat1) * Sin($lat_rad))
				$lon_rad = Mod(($long1 + $dlon_rad + $PI), 2 * $PI) - $PI ; origionally 'fmod(($long1+$dlon_rad + M_PI), 2*M_PI) - M_PI'
				$file &= _rad2deg($lon_rad) & ',' & _rad2deg($lat_rad) & ',' & $viewdistance_form & @CRLF
			Next
			; create footer
			$file &= '</coordinates>' & @CRLF & _
					'</LineString>' & @CRLF & _
					'</Placemark>' & @CRLF & _
					'</Document>' & @CRLF & _
					'</kml>'
			; write file
			FileWrite($filename, $file)
			Exit
		Case $msg = $GUI_EVENT_CLOSE
			ExitLoop
		Case Else
			;;;
	EndSelect
WEnd
Exit


Func _deg2rad($degree) ;convert degrees to radians
	Return ($degree * ($PI / 180))
EndFunc   ;==>_deg2rad

Func _rad2deg($radian) ;convert radians to degrees
	Return ($radian * (180 / $PI))
EndFunc   ;==>_rad2deg

